<template>
	<div class="app-container">
		<el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">

			<el-form-item label="配料单号" prop="orderCode">
				<el-input
					v-model="queryParams.orderCode"
					placeholder="请输入配料单号"
					clearable
					@keyup.enter.native="handleQuery"
				/>
			</el-form-item>
			<el-form-item label="物料编码" prop="materialCode">
				<el-input
					v-model="queryParams.materialCode"
					placeholder="请输入物料编码"
					clearable
					@keyup.enter.native="handleQuery"
				/>
			</el-form-item>
			<el-form-item label="物料描述" prop="materialDesc">
				<el-input
					v-model="queryParams.materialDesc"
					placeholder="请输入物料描述"
					clearable
					@keyup.enter.native="handleQuery"
				/>
			</el-form-item>

			<el-form-item>
				<el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
				<el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
			</el-form-item>
		</el-form>

		<el-row :gutter="10" class="mb8">
			<el-col :span="1.5">
				<el-button
					type="primary"
					plain
					icon="el-icon-plus"
					size="mini"
					@click="handleAdd"
					v-hasPermi="['wms:chargeorder:add']"
				>新增</el-button>
			</el-col>
			<el-col :span="1.5">
				<el-button
					type="success"
					plain
					icon="el-icon-edit"
					size="mini"
					:disabled="single"
					@click="handleUpdate"
					v-hasPermi="['wms:chargeorder:edit']"
				>修改</el-button>
			</el-col>
			<el-col :span="1.5">
				<el-button
					type="danger"
					plain
					icon="el-icon-delete"
					size="mini"
					:disabled="multiple"
					@click="handleDelete"
					v-hasPermi="['wms:chargeorder:remove']"
				>删除</el-button>
			</el-col>
			<el-col :span="1.5">
				<el-button
					type="warning"
					plain
					icon="el-icon-download"
					size="mini"
					@click="handleExport"
					v-hasPermi="['wms:chargeorder:export']"
				>导出</el-button>
			</el-col>
			<right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
		</el-row>

		<el-table v-loading="loading" :data="chargeorderList" @selection-change="handleSelectionChange">
			<el-table-column type="selection" width="55" align="center" />
      <el-table-column label="序号" type="index"   :index='indexMethod'> </el-table-column>
			<el-table-column label="工厂编码" align="center" prop="siteCode"v-if="false" />
			<el-table-column label="id" align="center" prop="id" v-if="false" />
			<el-table-column label="配料单号" align="center" prop="orderCode" />
			<el-table-column label="物料编码" align="center" prop="materialCode" />
			<el-table-column label="物料描述" align="center" prop="materialDesc" />
			<
			<el-table-column label="数量" align="center" prop="planNumber" />
			<el-table-column label="单位" align="center" prop="unit" />
			<el-table-column label="实际数量" align="center" prop="realityNumber" />
			<el-table-column label="订单状态" align="center" prop="orderStatus" />

			<el-table-column label="供应商编码" align="center" prop="supplierCode" v-if="false" />
			<el-table-column label="供应商名称" align="center" prop="supplierName" />

			<el-table-column label="创建人" align="center" prop="createBy" />
			<el-table-column label="创建时间" align="center" prop="createDate" width="180">
				<template slot-scope="scope">
					<span>{{ parseTime(scope.row.createDate, '{y}-{m}-{d}') }}</span>
				</template>
			</el-table-column>


		</el-table>

		<pagination
			v-show="total>0"
			:total="total"
			:page.sync="queryParams.pageNum"
			:limit.sync="queryParams.pageSize"
			@pagination="getList"
		/>

		<!-- 添加或修改粉料配料对话框 -->
		<el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
			<el-form ref="form" :model="form" :rules="rules" label-width="80px">



				<el-form-item label="计划日期" prop="planDate">
					<el-date-picker clearable
						v-model="form.planDate"
						type="date"
						value-format="yyyy-MM-dd"
						placeholder="请选择计划日期">
					</el-date-picker>
				</el-form-item>

				<el-form-item label="备注" prop="Remark">
					<el-input v-model="form.Remark" placeholder="请输入备注" />
				</el-form-item>


			</el-form>
      <div  class="dialog-footer">
        <el-button type="primary" @click="open">新增</el-button>

        <el-button @click="cancel">删除</el-button>
      </div>
			<div slot="footer" class="dialog-footer">
				<el-button type="primary" @click="submitForm">确 定</el-button>
				<el-button @click="cancel">取 消</el-button>
			</div>
		</el-dialog>
	</div>
</template>

<script>
import { listChargeorder, getChargeorder, delChargeorder, addChargeorder, updateChargeorder } from "@/api/wms/chargeorder";

export default {
	name: "Chargeorder",
	data() {
		return {
			// 遮罩层
			loading: true,
			// 选中数组
			ids: [],
			// 非单个禁用
			single: true,
			// 非多个禁用
			multiple: true,
			// 显示搜索条件
			showSearch: true,
			// 总条数
			total: 0,
			// 粉料配料表格数据
			chargeorderList: [],
			// 弹出层标题
			title: "",
			// 是否显示弹出层
			open: false,
			// 查询参数
			queryParams: {
				pageNum: 1,
				pageSize: 10,
				siteCode: null,
				orderCode: null,
				materialCode: null,
				materialDesc: null,
				planDate: null,
				planNumber: null,
        unit: null,
				realityNumber: null,
				orderStatus: null,
				userDefined1: null,
				userDefined2: null,
				userDefined3: null,
				userDefined4: null,
				userDefined5: null,
				userDefined6: null,
				userDefined7: null,
				userDefined8: null,
				userDefined9: null,
				userDefined10: null,
				userDefined11: null,
				supplierCode: null,
				supplierName: null,
				Remark: null,
				createBy: null,
				createDate: null,
				lastUpdateBy: null,
				lastUpdateDate: null,
				Active: null,
				enterpriseId: null,
				enterpriseCode: null
			},
			// 表单参数
			form: {},
			// 表单校验
			rules: {
			},
      addDialogTitle: '添加项目',
      addDialogVisible: false,
      newItemForm: {
        name: ''
        // 其他表单项
      },
		};
	},
	created() {
		this.getList();
	},
	methods: {
    showAddDialog() {
      this.addDialogVisible = true;
    },
    cancelAddDialog() {
      this.addDialogVisible = false;
    },
    confirmAddDialog() {
      // 在这里处理添加操作，例如调用后端API进行保存
      // 添加成功后可以关闭弹出窗口
      this.addDialogVisible = false;
    },
		/** 查询粉料配料列表 */
		getList() {
			this.loading = true;
			listChargeorder(this.queryParams).then(response => {
				this.chargeorderList = response.rows;
				this.total = response.total;
				this.loading = false;
			});
		},
		// 取消按钮
		cancel() {
			this.open = false;
			this.reset();
		},
		// 表单重置
		reset() {
			this.form = {
				siteCode: null,
        id: null,
				orderCode: null,
				materialCode: null,
				materialDesc: null,
				planDate: null,
				planNumber: null,
        unit: null,
				realityNumber: null,
				orderStatus: null,
				userDefined1: null,
				userDefined2: null,
				userDefined3: null,
				userDefined4: null,
				userDefined5: null,
				userDefined6: null,
				userDefined7: null,
				userDefined8: null,
				userDefined9: null,
				userDefined10: null,
				userDefined11: null,
				supplierCode: null,
				supplierName: null,
				Remark: null,
				createBy: null,
				createDate: null,
				lastUpdateBy: null,
				lastUpdateDate: null,
				Active: null,
				enterpriseId: null,
				enterpriseCode: null
			};
			this.resetForm("form");
		},
		/** 搜索按钮操作 */
		handleQuery() {
			this.queryParams.pageNum = 1;
			this.getList();
		},
		/** 重置按钮操作 */
		resetQuery() {
			this.resetForm("queryForm");
			this.handleQuery();
		},
		// 多选框选中数据
		handleSelectionChange(selection) {
			this.ids = selection.map(item => item.id)
			this.single = selection.length!==1
			this.multiple = !selection.length
		},

		/** 新增按钮操作 */
		handleAdd() {
			this.reset();
			this.open = true;
			this.title = "添加粉料配料单";
		},
		/** 修改按钮操作 */
		handleUpdate(row) {
			this.reset();
			const id = row.id || this.ids
			getChargeorder(id).then(response => {
				this.form = response.data;
				this.open = true;
				this.title = "修改粉料配料";
			});
		},
    open() {
      this.$prompt('请输入邮箱', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        inputPattern: /[\w!#$%&'*+/=?^_`{|}~-]+(?:\.[\w!#$%&'*+/=?^_`{|}~-]+)*@(?:[\w](?:[\w-]*[\w])?\.)+[\w](?:[\w-]*[\w])?/,
        inputErrorMessage: '邮箱格式不正确'
      }).then(({ value }) => {
        this.$message({
          type: 'success',
          message: '你的邮箱是: ' + value
        });
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '取消输入'
        });
      });
    },

		/** 提交按钮 */
		submitForm() {
			this.$refs["form"].validate(valid => {
				if (valid) {
					if (this.form.id != null) {
						updateChargeorder(this.form).then(response => {
							this.$modal.msgSuccess("修改成功");
							this.open = false;
							this.getList();
						});
					} else {
						addChargeorder(this.form).then(response => {
							this.$modal.msgSuccess("新增成功");
							this.open = false;
							this.getList();
						});
					}
				}
			});
		},
		/** 删除按钮操作 */
		handleDelete(row) {
			const IDs = row.id || this.ids;
			this.$modal.confirm('是否确认删除粉料配料编号为"' + IDs + '"的数据项？').then(function() {
				return delChargeorder(IDs);
			}).then(() => {
				this.getList();
				this.$modal.msgSuccess("删除成功");
			}).catch(() => {});
		},
		/** 导出按钮操作 */
		handleExport() {
			this.download('wms/chargeorder/export', {
				...this.queryParams
			}, `chargeorder_${new Date().getTime()}.xlsx`)
		}
	}
};
</script>
